<template>
  <div>
    <!--<template>
      <hsc-window-style-white>
        <hsc-window
          style=" z-index:2000"
          :resizable="true"
          :isScrollable="true"
          :minHeight="300"
          :maxHeight="500"
          :minWidth="300"
          :maxWidth="400"
          title="Viewer Objects"
          :width="400"
          :height="700"
        >
          <json-view :data="$data.puntoContacto" />
        </hsc-window>
      </hsc-window-style-white>
    </template>-->
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs" :large="false">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Gestion Puntos de Contacto</strong>
    </div>
    <div class="pl-10 pr-10 contSecc">
      <div class="titSec">Gestiona la asignación de un punto de contacto</div>
      <div class="CampoOblogario">
        Campo requerido
        <span class="tRojo">*</span>
      </div>
      <br />
      <div class="gris">
        <v-row>
          <v-col class="pb-sm-0" :cols="12" :sm="12" :md="5" :lg="5" :xl="4">
            <v-autocomplete
              v-model="searchPuntoContacto"
              :loading="isSearching"
              :items="metadata.puntosContacto"
              :search-input.sync="searchPuntoContactoSync"
              clearable
              hide-no-data
              hide-details
              hide-selected
              item-text="ceco_descripcion"
              item-value="ceco"
              @change = "getPuntoContacto()"
              placeholder="Buscar Ceco"
              label="Buscar Ceco"
              solo
              return-object
            />
          </v-col>
          <v-col class="pt-sm-0" :cols="12" :sm="12" :md="4" :lg="3" :xl="2">
            <v-btn
              block
              class="mr-6 mt-md-3 mt-sm-0"
              depressed
              dark
              tile
              color="secundary"
              :class="[
                { desac: isLoadingPuntoContacto || !searchPuntoContacto }
              ]"
              @click="getPuntoContacto()"
              >Buscar</v-btn
            >
          </v-col>
        </v-row>
      </div>
      <v-alert
        v-if="isNoActivePuntoContacto"
        color="warning"
        :icon="false"
        type="warning"
      >
        <div class="text-center">
          <v-icon>mdi-alert</v-icon
          ><b>
            El Ceco del Punto de contacto está "{{
              puntoContacto.detalle.estatus
            }}" no podrás asignarle una Franquicia o hacer modificaciones en sus
            datos</b
          ><v-icon>mdi-alert</v-icon>
        </div>
      </v-alert>
      <div class="titSec" v-show="infoPuntoContactoResult">
        Datos del punto de contacto:
        <span v-if="!puntoContacto.ceco">????</span>
        <span v-else>{{ searchPuntoContacto.ceco_descripcion }}</span>
      </div>
      <div class="gris" v-show="infoPuntoContactoResult">
        <v-row>
          <v-col :cols="12" :sm="12" :md="5" :lg="5" :xl="3">
            <v-text-field
              disabled
              v-model="puntoContacto.ceco"
              label="Ceco del Punto de contacto"
            >
            </v-text-field>
          </v-col>
          <v-col :cols="12" :sm="12" :md="5" :lg="5" :xl="3">
            <v-text-field
              disabled
              v-model="puntoContacto.descripcion"
              label="Nombre de Punto de contacto"
            >
            </v-text-field>
          </v-col>
          <v-col :cols="12" :sm="12" :md="5" :lg="5" :xl="3">
            <v-text-field
              disabled
              v-model="puntoContacto.detalle.numero_economico"
              label="Número económico"
            >
            </v-text-field>
          </v-col>
          <v-col :cols="12" :sm="12" :md="5" :lg="5" :xl="3">
            <v-text-field
              disabled
              v-model="puntoContacto.detalle.estatus"
              label="Estatus"
            >
            </v-text-field>
          </v-col>
        </v-row>
        <v-row>
          <v-col :cols="12" :sm="12" :md="5" :lg="5" :xl="3">
            <v-text-field
              disabled
              v-model="puntoContacto.detalle.referencia_ceco"
              label="Padre operativa"
            >
            </v-text-field>
          </v-col>
          <v-col :cols="12" :sm="12" :md="5" :lg="5" :xl="3">
            <v-text-field
              disabled
              v-model="puntoContacto.detalle.region"
              label="Regional"
            >
            </v-text-field>
          </v-col>
          <v-col :cols="12" :sm="12" :md="5" :lg="5" :xl="3">
            <v-text-field
              disabled
              v-model="puntoContacto.detalle.zona"
              label="Zona"
            >
            </v-text-field>
          </v-col>
          <v-col :cols="12" :sm="12" :md="5" :lg="5" :xl="3">
            <v-text-field
              disabled
              v-model="puntoContacto.detalle.territorio"
              label="Territorio"
            >
            </v-text-field>
          </v-col>
        </v-row>
        <v-row>
          <v-col :cols="12" :sm="12" :md="5" :lg="5" :xl="3">
            <v-text-field
              disabled
              v-model="puntoContacto.detalle.responsable"
              label="Gerente responsable"
            >
            </v-text-field>
          </v-col>
          <v-col :cols="12" :sm="12" :md="5" :lg="5" :xl="3">
            <v-text-field
              disabled
              v-model="puntoContacto.detalle.numero_responsable"
              label="Teléfono del Punto de contacto"
            >
            </v-text-field>
          </v-col>
          <v-col :cols="12" :sm="12" :md="5" :lg="5" :xl="6">
            <v-text-field
              disabled
              v-model="puntoContacto.detalle.direccion"
              label="Dirección del Punto de contacto"
            >
            </v-text-field>
          </v-col>
        </v-row>
      </div>
      <template v-if="!isNoActivePuntoContacto || isPuntoContactoAsignado">
        <div class="titSec" v-show="infoPuntoContactoResult">Asignación de la franquicia</div>
        <div class="CampoOblogario" v-show="infoPuntoContactoResult">
          Campo requerido
          <span class="tRojo">*</span>
        </div>
        <div class="gris" v-show="infoPuntoContactoResult">
          <v-row>
            <v-col :cols="12" :sm="12" :md="5" :lg="5" :xl="3">
              Selecciona la franquicia
              <span class="tRojo">*</span>
              <v-autocomplete
                v-model="puntoContacto.asignacion.franquicia"
                :items="metadata.franquicias"
                item-text="descripcion"
                item-value="id_franquicia"
                label="Selecciona la franquicia"
                background-color="white"
                @change="getDataFranquicia()"
                :disabled="isDisabledAsignacion"
                solo
                single-line
                return-object
                :error="$v.puntoContacto.asignacion.franquicia.$error"
              >
                <template
                  v-if="$v.puntoContacto.asignacion.franquicia.$error"
                  v-slot:append-outer
                >
                  <v-popover placement="bottom-end" offset="16">
                    <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                    <template slot="popover">
                      <div
                        @click="$v.puntoContacto.asignacion.franquicia.$reset()"
                        v-close-popover
                      >
                        <span
                          v-if="
                            !$v.puntoContacto.asignacion.franquicia.required
                          "
                          >¡No te olvides de éste campo!</span
                        >
                      </div>
                    </template>
                  </v-popover>
                </template>
              </v-autocomplete>
            </v-col>
            <v-col :cols="12" :xs="12" :sm="12" :md="3" :lg="3" :xl="3">
              Selecciona las categorías que presenta
              <span class="tRojo">*</span>
              <br />
              <v-autocomplete
                class="categorias"
                v-model="puntoContacto.asignacion.categorias"
                :items="metadata.categoriasFranquicia"
                item-value="id_categoria"
                item-text="descripcion"
                no-data-text="No se encontrarón categorías"
                :disabled="isDisabledAsignacion"
                chips
                small-chips
                multiple
                solo
                label="Categoría"
                :loading="isLoadingFranquicia"
                return-object
                :error="$v.puntoContacto.asignacion.categorias.$error"
              >
                <template v-slot:selection="{ item, index }">
                  <v-chip label small v-if="index < 3">
                    <span>{{ item.descripcion }}</span>
                  </v-chip>
                  <span v-if="index === 3" class="grey--text caption">
                    (+{{ puntoContacto.asignacion.categorias.length - 3 }}
                    otros)
                  </span>
                </template>
                <template
                  v-if="$v.puntoContacto.asignacion.categorias.$error"
                  v-slot:append-outer
                >
                  <v-popover placement="bottom-end" offset="16">
                    <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                    <template slot="popover">
                      <span
                        @click="$v.puntoContacto.asignacion.categorias.$reset()"
                        v-close-popover
                      >
                        <span
                          v-if="
                            !$v.puntoContacto.asignacion.categorias.required
                          "
                          >¡No te olvides de éste campo!</span
                        >
                      </span>
                    </template>
                  </v-popover>
                </template>
              </v-autocomplete>
            </v-col>
            <v-col :cols="12" :sm="12" :md="5" :lg="5" :xl="3">
              Selecciona el modelo
              <span class="tRojo">*</span>
              <v-autocomplete
                v-model="puntoContacto.asignacion.modelo"
                :items="metadata.modelosFranquicia"
                item-text="nombre_modelo"
                item-value="id_modelo"
                label="Selecciona el modelo"
                :disabled="isDisabledAsignacion"
                background-color="white"
                persistent-hint
                solo
                single-line
                return-object
                :loading="isLoadingFranquicia"
                :error="$v.puntoContacto.asignacion.modelo.$error"
              >
                <template
                  v-if="$v.puntoContacto.asignacion.modelo.$error"
                  v-slot:append-outer
                >
                  <v-popover placement="bottom-end" offset="16">
                    <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                    <template slot="popover">
                      <div
                        @click="$v.puntoContacto.asignacion.modelo.$reset()"
                        v-close-popover
                      >
                        <span
                          v-if="!$v.puntoContacto.asignacion.modelo.required"
                          >¡No te olvides de éste campo!</span
                        >
                      </div>
                    </template>
                  </v-popover>
                </template>
              </v-autocomplete>
            </v-col>
            <template>
              <v-col
                v-for="(tipoFormato, indexTipoFormato) in puntoContacto
                  .asignacion.tipo_formatos"
                :key="indexTipoFormato"
                :cols="12"
                :sm="12"
                :md="5"
                :lg="5"
                :xl="3"
              >
                {{ tipoFormato.descripcion }}
                <span class="tRojo">*</span>
                <v-autocomplete
                  v-model="tipoFormato.formato"
                  :items="formatosByTipo(tipoFormato.id_tipo_formato)"
                  item-text="descripcion"
                  item-value="id_formato"
                  :label="tipoFormato.descripcion"
                  background-color="white"
                  :disabled="isNoActive"
                  solo
                  single-line
                  return-object
                  :error="
                    $v.puntoContacto.asignacion.tipo_formatos.$each[
                      indexTipoFormato
                    ].$error
                  "
                >
                  <template
                    v-if="
                      $v.puntoContacto.asignacion.tipo_formatos.$each[
                        indexTipoFormato
                      ].$error
                    "
                    v-slot:append-outer
                  >
                    <v-popover placement="bottom-end" offset="16">
                      <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                      <template slot="popover">
                        <div
                          @click="
                            $v.puntoContacto.asignacion.tipo_formatos.$each[
                              indexTipoFormato
                            ].$reset()
                          "
                          v-close-popover
                        >
                          <span
                            v-if="
                              !$v.puntoContacto.asignacion.tipo_formatos.$each[
                                indexTipoFormato
                              ].required
                            "
                            >¡No te olvides de éste campo!</span
                          >
                        </div>
                      </template>
                    </v-popover>
                  </template>
                </v-autocomplete>
              </v-col>
            </template>
          </v-row>
        </div>
      </template>
      <div
        v-show="infoPuntoContactoResult"
        v-if="!isNoActivePuntoContacto || isPuntoContactoAsignado"
        class="btnCenter"
      >
        <v-btn
          class="mr-6"
          depressed
          dark
          tile
          color="secundary"
          @click="isDialogCancel = true"
          :class="[{ desac: !hasGlobalChanges || isNoActive }]"
          >Cancelar cambios</v-btn
        >
        <v-btn
          depressed
          dark
          tile
          color="primary"
          @click="saveAsignacion()"
          :class="[
            { desac: !hasGlobalChanges || isNoActive || isSavingAsignacion }
          ]"
          >Guardar cambios</v-btn
        >
      </div>
    </div>
    <template>
      <v-dialog v-model="isDialogCancel" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              ¿Seguro que deseas
              <strong>cancelar</strong> los cambios realizados?
            </div>
          </v-card-title>
          <v-card-text></v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="secondary"
                @click="isDialogCancel = false"
                >No, cancelar</v-btn
              >
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="cancelGlobalChanges()"
                >Si, continuar</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="isDialogSave" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              ¡Se han
              <strong>guardado los cambios de manera exitosa!</strong>
            </div>
          </v-card-title>
          <v-card-text></v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="isDialogSave = false"
                >Regresar</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="isDialogErrorValidation" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal titModaleError">
              <strong>¡Oh oh!</strong>
              Tienes algunos conflictos de validación
            </div>
          </v-card-title>
          <v-card-text
            >¡No hay de que preocuparse! Solo tienes que
            corregirlos.</v-card-text
          >
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="error"
                @click="isDialogErrorValidation = false"
                >Aceptar</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="isNotFoundPuntoContacto" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              <strong>No hay coincidencias. </strong>
              Verifica el Ceco colocado.
            </div>
          </v-card-title>
          <v-card-text>
            <span>Verifica que hayas escrito correctamente el Ceco.</span>
          </v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="secondary"
                @click="isNotFoundPuntoContacto = false"
                >Volver a intentar</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </template>
    <LeavePage ref="LeavePage" />
  </div>
</template>
<script>
import { required } from "vuelidate/lib/validators";
import axios from "axios";
import store from "@/store";
import LeavePage from "@/views/secure/commons/LeavePage.vue";
const serviceLocalStorage = store.state.serviceLocalStorage;
const user = serviceLocalStorage.userToken();
export default {
  name: "Component-GestionPuntosContacto",
  components: {
    LeavePage
  },
  data() {
    return {
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home"
          }
        },
        {
          text: "Modelo de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_franquicia"
          }
        },
        {
          text: "Puntos de Contacto Home",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_franquicia_home_puntos_contacto"
          }
        },
        {
          text: "Gestión Puntos de Contacto",
          disabled: true
        }
      ],
      searchPuntoContacto: null,
      searchPuntoContactoSync: null,
      metadata: {
        puntosContacto: [],
        franquicias: [],
        categoriasFranquicia: [],
        modelosFranquicia: [],
        formatosFranquicia: []
      },
      isSearching: false,
      isLoadingPuntoContacto: false,
      isLoadingPuntosContacto: false,
      isLoadingFranquicia: false,
      isDialogErrorValidation: false,
      isDialogSave: false,
      isDialogCancel: false,
      isNotFoundPuntoContacto: false,
      isNoActivePuntoContacto: false,
      isSavingAsignacion: false,
      defaultDataPuntoContacto: null,
      puntoContactoBackup: null,
      infoPuntoContactoResult: false,
      puntoContacto: {
        id_punto_contacto: null,
        ceco: null,
        descripcion: null,
        detalle: {
          ceco: null,
          referencia_ceco: null,
          numero_economico: null,
          id_estatus: null,
          estatus: null,
          id_territorio: null,
          territorio: null,
          id_zona: null,
          zona: null,
          id_region: null,
          region: null,
          numero_responsable: null,
          responsable: null,
          id_pais: null,
          pais: null,
          id_estado: null,
          estado: null,
          municipio: null,
          calle: null,
          fecha_carga: null
        },
        asignacion: {
          id_punto_contacto_franquicia_modelo: null,
          id_punto_contacto: null,
          franquicia: null,
          modelo: null,
          categorias: [
            /*{
                    id_categoria_punto_contacto: null,
                    id_punto_contacto_franquicia_modelo: null,
                    id_categoria: null
                }*/
          ],
          tipo_formatos: [
            /*{
                    id_tipo_formato: null,
                    descripcion: null,
                    formato: {
                        id_formato: null,
                        id_punto_contacto_franquicia_modelo: null
                    }
                }*/
          ],
          id_empleado: null,
          fecha_asignacion: null
        }
      }
    };
  },
  validations: {
    puntoContacto: {
      asignacion: {
        franquicia: {
          required
        },
        categorias: {
          required
        },
        modelo: {
          required
        },
        tipo_formatos: {
          $each: {
            formato: {
              required
            }
          }
        }
      }
    }
  },
  watch: {
    searchPuntoContactoSync(val) {
      if (!val) {
        this.searchPuntoContacto = null;
        this.invokeDefaultEmpyDataPuntoContacto();
      }
    }
  },
  computed: {
    isPuntoContactoAsignado() {
      return (
        this.puntoContacto.asignacion.id_punto_contacto_franquicia_modelo !==
          null && this.isDisabledAsignacion
      );
    },
    isDisabledAsignacion() {
      if (this.puntoContacto.detalle && this.puntoContacto.detalle.id_estatus) {
        return (
          this.puntoContacto.detalle &&
          this.puntoContacto.detalle.id_estatus != 1
        );
      }
      return this.puntoContacto.ceco === null;
    },
    isNoActive() {
      if (this.puntoContacto.detalle && this.puntoContacto.detalle.id_estatus) {
        return (
          this.puntoContacto.detalle &&
          this.puntoContacto.detalle.id_estatus != 1
        );
      }
      return true;
    },
    hasGlobalChanges() {
      if (this.puntoContactoBackup) {
        const originalValue = JSON.stringify(this.puntoContactoBackup).replace(
          /"/g,
          ""
        );
        const currentValue = JSON.stringify(this.puntoContacto).replace(
          /"/g,
          ""
        );
        return originalValue !== currentValue;
      } else {
        return this.puntoContacto.id_punto_contacto === undefined;
      }
    }
  },
  methods: {
    formatosByTipo(idTipoFormato) {
      return this.metadata.formatosFranquicia.filter(
        (itemFormato) => itemFormato.id_tipo_formato === idTipoFormato
      );
    },
    getPuntosContacto() {
      var self = this;
      self.isLoadingPuntosContacto = true;
      axios
        .get("/punto/contacto/secure/get")
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.setPuntosContacto(data);
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {
          self.isLoadingPuntosContacto = false;
        });
    },
    setPuntosContacto(data) {
      if (data) {
        data = data.filter((item, index) => {
          item.ceco_descripcion = item.ceco + " - " + item.descripcion;
          return item;
        });
      }
      this.metadata.puntosContacto = data;
    },
    getFranquicias() {
      var self = this;
      self.isLoadingFranquicia = true;
      axios
        .get("/franquicia/secure/get")
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.setFranquicias(data);
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {
          self.isLoadingFranquicia = false;
        });
    },
    setFranquicias(data) {
      this.metadata.franquicias = data;
    },
    getDataFranquicia() {
      if (this.puntoContacto.asignacion.franquicia) {
        this.getCategoriasFranquicia();
        this.getModelosFranquicia();
      }
    },
    getCategoriasFranquicia() {
      var self = this;
      axios
        .get(
          "/negocio/secure/franquicia/get/data/" +
            this.puntoContacto.asignacion.franquicia.id_franquicia
        )
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.setCategoriasFranquicia(data);
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    setCategoriasFranquicia(data) {
      let categoriasFranquicia = [];
      if (data) {
        data.forEach((itemNegocio, indexItemNegocio) => {
          if (itemNegocio.categorias) {
            itemNegocio.categorias.forEach(
              (itemCategoria, indexItemCategoria) => {
                categoriasFranquicia.push(itemCategoria);
              }
            );
          }
        });
      }
      this.metadata.categoriasFranquicia = categoriasFranquicia;
    },
    getModelosFranquicia() {
      var self = this;
      axios
        .get(
          "/modelos/franquicia/secure/get/" +
            this.puntoContacto.asignacion.franquicia.id_franquicia
        )
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.setModelosFranquicia(data);
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    setModelosFranquicia(data) {
      this.metadata.modelosFranquicia = data;
    },
    getFormatosFranquicia() {
      var self = this;
      axios
        .get("/formato/secure/get/")
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.setFormatosFranquicia(data);
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    setFormatosFranquicia(data) {
      this.metadata.formatosFranquicia = data;
    },
    getPuntoContacto() {
      if (this.searchPuntoContacto) {
        var self = this;
        self.isNoActivePuntoContacto = false;
        self.isLoadingPuntoContacto = true;
        axios
          .get("/punto/contacto/secure/get/" + this.searchPuntoContacto.ceco)
          .then((response) => {
            if (response) {
              if (response.data.status_code === 200) {
               self.infoPuntoContactoResult = true;
                if (
                  response.data.track_code &&
                  response.data.track_code === 3006
                ) {
                  self.isNotFoundPuntoContacto = true;
                  self.invokeDefaultEmpyDataPuntoContacto();
                } else {
                  const data = response.data.data;
                  if (data) {
                    self.setPuntoContacto(data);
                    self.getDataFranquicia();
                    if (
                      self.searchPuntoContacto &&
                      self.searchPuntoContacto.id_estatus !== 1
                    ) {
                      self.isNoActivePuntoContacto = true;
                    }
                  }
                }
              }
            }
          })
          .catch((error) => {
            console.log(error);
          })
          .finally(function() {
            self.isLoadingPuntoContacto = false;
          });
      }
    },
    setPuntoContacto(data) {
      data.asignacion.id_empleado = user.empleado;
      this.puntoContactoBackup = JSON.parse(JSON.stringify(data));
      this.puntoContacto = data;
    },
    cancelGlobalChanges() {
      this.puntoContacto = JSON.parse(JSON.stringify(this.puntoContactoBackup));
      this.isDialogCancel = false;
      this.$v.$reset();
    },
    saveAsignacion() {
      this.$v.$touch();
      if (!this.$v.$invalid) {
        var self = this;
        this.isSavingAsignacion = true;
        axios
          .patch("/punto/contacto/secure/cu", this.puntoContacto)
          .then((response) => {
            if (response) {
              if (response.data.status_code === 200) {
                const data = response.data.data;
                if (data) {
                  self.isDialogSave = true;
                  self.invokeDefaultEmpyDataPuntoContacto();
                }
              }
            }
          })
          .catch((error) => {
            console.log(error);
          })
          .finally(function() {
            self.isSavingAsignacion = false;
          });
      } else {
        this.isDialogErrorValidation = true;
      }
    },
    snapshotDataPuntoContacto() {
      let puntoContacto = JSON.stringify(this.puntoContacto);
      this.defaultDataPuntoContacto = JSON.parse(puntoContacto);
    },
    invokeDefaultEmpyDataPuntoContacto() {
      let puntoContacto = JSON.parse(
        JSON.stringify(this.defaultDataPuntoContacto)
      );
      this.puntoContacto = puntoContacto;
      this.$v.$reset();
    }
  },
  created() {
    this.snapshotDataPuntoContacto();
    this.getPuntosContacto();
    this.getFranquicias();
    this.getFormatosFranquicia();
  },
  beforeRouteLeave: function(to, from, next) {
    this.$refs.LeavePage.beforeRouteLeave(
      to,
      from,
      next,
      this.hasGlobalChanges
    );
  }
};
</script>
